#!/usr/bin/perl

use Mysql;
use POSIX qw(strftime);
use CGI;

# IPTable log analyzer
# Copyright (C) 2002 Gerald GARCIA
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Plac<B2>e - Suite 330, Boston, MA  02111-1307, USA.
#
# Contact author : gege@gege.org

# $Id: lidslog.pl,v 1.1 2003/05/26 21:24:40 xie Exp $

use Socket; 


######################################################################################################
#################        C O N F I G     S E C T I O N             ###################################
######################################################################################################

my $dsn = 'DBI:mysql:lids:127.0.0.1';
my $db_user_name = 'root';
my $db_password = '1234';
my $log_file = '/var/log/messages';
my $pid_file = "/var/run/lidslog.pid";

######################################################################################################
#################        E N D   O F   C O N F I G     S E C T I O N       ###########################
######################################################################################################


my $go_to_background=($ARGV[0] eq '--background');

$SIG{INT} = \&got_int;

my ($id, $password);
#my $dbh = DBI->connect($dsn, $db_user_name, $db_password) || die "open database failed:$!\n";

my $dbh = Mysql->connect($localhost, 'lids' , 'root', '1234')
                or die "Couldn't connect to database: " . Mysql->errstr;


# get the short name of months according to the locale
# thanks to Bill Garrett <memesis at users.sourceforge.net>
my(%m);
my($month_nb);
for $month_nb (0..11) {
    $m{strftime("%b", 0, 0, 0, 1, $month_nb, 96)}=sprintf("%02d",$month_nb+1);
}

my($log_tag)="LIDS";

open(LOG_FILE,"tail -F  $log_file 2>/dev/null |") or die "Unable to open log file $log_file : $!\n";

#fork to background

print "about to read $log_file\n";


while (<LOG_FILE>) {
  	if (!/$log_tag/) { next; }
  	my(@entry_split)=split / +/;
  	my(%entry);

  #year is not in syslog date format... try to guess it from the local time
  # ***TODO*** what happen when the year change ?
 	 my($year);
  	(undef,undef,undef,undef,undef,$year,undef,undef,undef) = localtime(time);
  	$year += 1900;

  	$entry{'date'}="$year-".$m{shift(@entry_split)}."-".shift(@entry_split)." ".shift(@entry_split);
  	$entry{'host'}=shift(@entry_split);
  	shift(@entry_split); # kernel:
  	shift(@entry_split); # LIDS:  

# May 25 23:59:00 lids kernel: LIDS: crond (dev 3:2 inode 99759) pid 516 ppid 1 uid/gid (0/0) on (null tty) : access hidden file cron
		chop($_);
  	if($_=~/(.*?) kernel\: LIDS\: (\w+) \(dev (.*?) inode (\w+)\) pid (\d+) ppid (\d+) uid\/gid \((\d+)\/(\d+)\) on \((.*?)\) : / ) {
		$entry{'program'} = $2;
		($a,$b) = split(/:/,$3);
		$entry{'dev'} = $a*8+$b;
		$entry{'inode'} = $4;
		$entry{'pid'} = $5;
		$entry{'ppid'} = $6;
		$entry{'uid'}=$7;
		$entry{'gid'}=$8;
		$entry{'tty'}= $9;
		$entry{'reason'} = $';
	}


  	my($dummy)="'".$entry{"host"}."','".$entry{"date"}."','".$entry{"program"}."','".$entry{"dev"}."','".$entry{'inode'}."','".$entry{'pid'}."','".$entry{'ppid'}."','".$entry{'uid'}."','".$entry{'gid'}."','".$entry{'tty'}."','".$entry{'reason'}."'";

  print "output: $dummy\n";


  $dbh->query("insert into logs 
          (host,date,program,dev, inode, pid, ppid, uid, gid, tty, reason) 
 	values ($dummy)");
}
print "close here\n";
 # $dbh->disconnect();
